//-----------------------------------------------------------------------------
// Created on: 08 October 2015
// Created by: Sergey SLYADNEV
// Web-site: http://quaoar.su/blog
//-----------------------------------------------------------------------------

#ifndef Opt_FunctionWithGradient_HeaderFile
#define Opt_FunctionWithGradient_HeaderFile

// Opt includes
#include <Opt_Function.h>

//! Target function to optimize with gradient-wise methods.
template <typename T_DIMENSION>
class Opt_FunctionWithGradient : public Opt_Function<T_DIMENSION>
{
public:

  typedef T_DIMENSION t_coord;

public:

  virtual t_coord Gradient(const t_coord& x) = 0;

};

#endif
