@echo off

set VCVER=%1
set ARCH=%2
set CONFIG=%3

if /I "%ARCH%" == "win32" set ARCH=32
if /I "%ARCH%" == "win64" set ARCH=64

if "%VCVER%"  == "" set VCVER=vc12
if "%ARCH%"   == "" set ARCH=64
if "%CONFIG%" == "" set CONFIG=

set DEB=
if not "%CONFIG%" == "" (
  if /I "%CONFIG%" == "Debug" (
    set DEB=d
  ) else if /I "%CONFIG%" == "Release" (
    set DEB=
  ) else (
    echo Error: third argument ^(%3^) should specify build mode,
    echo one of: Debug or Release
    exit
  )
)

if exist %~dp0custom.bat call %~dp0custom.bat

rem ===========================================================================
rem Setting CCDIST environment 
rem ===========================================================================

if "%CCDIST_ROOT%" == "" set "CCDIST_ROOT=%~dp0"
if "%CCDIST_BIN%"  == "" set "CCDIST_BIN=%CCDIST_ROOT%win%ARCH%\%VCVER%\bin%DEB%"
if "%CCDIST_DATA%" == "" set "CCDIST_DATA=%CCDIST_ROOT%data"

rem ===========================================================================
rem Adjust PATH variable
rem ===========================================================================

set "PATH=%CCDIST_BIN%;%PATH%"
