//-----------------------------------------------------------------------------
// Created on: 13 October 2015
// Created by: Sergey SLYADNEV
// Web-site: http://quaoar.su/blog
//-----------------------------------------------------------------------------

#ifndef BSpl_BasisN_HeaderFile
#define BSpl_BasisN_HeaderFile

//! Algorithm calculating B-spline basis function.
//! ATTENTION: this algorithm is not optimal!
class BSpl_BasisN
{
// Construction & destruction:
public:

  BSpl_BasisN();
  virtual ~BSpl_BasisN();

public:

  double operator()(const double  u,
                    const double* pU,
                    const int     nU,
                    const int     p,
                    const int     i) const;

};

#endif
