//-----------------------------------------------------------------------------
// Created on: 08 October 2015
// Created by: Sergey SLYADNEV
// Web-site: http://quaoar.su/blog
//-----------------------------------------------------------------------------

#ifndef Opt_Function_HeaderFile
#define Opt_Function_HeaderFile

// Aux includes
#include <Aux_SharedPtr.h>

//! Target function to optimize.
template <typename T_DIMENSION>
class Opt_Function : public Aux_SharedObject
{
public:

  typedef T_DIMENSION t_coord;

public:

  virtual double Value(const t_coord& x) = 0;

};

#endif
